// Fichier Led.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 * Code source de la librairie permettant de commander  *
 * les leds de la carte capteur.						*
 *                                                      *
 * .Date de cration : 27/01/08                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *                                                      *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <p18f452.h>		// Librairie du PIC utilis


#include "led.h"





// --------------------------------------------------------------------------
/* Initialise les ports des leds en sortie
 * Puis teind toutes les leds
 *  Pas de paramtre 
*/
void Led_Init (void)
{
	TRIS_LEDS_BLEUS		=0;		// Configure le bit en sortie
	TRIS_LEDS_BLANCHES	=0;		// Configure le bit en sortie
	TRIS_LEDS_ROUGES	=0;		// Configure le bit en sortie
	
	LEDS_BLEUS=0;
	LEDS_BLANCHES=0;
	LEDS_ROUGES=0;
		
}



// --------------------------------------------------------------------------
/* Commande les leds bleus
 *  0 = Leds teintes
 *  1 = Leds allumes
*/
void Leds_Bleus (unsigned char Value)
{
	LEDS_BLEUS=Value;		// Place l'inverse de la valeur sur le port (led active  l'tat bas)
}




// --------------------------------------------------------------------------
/* Commande les leds Blanches
 *  0 = Leds teintes
 *  1 = Leds allumes
*/
void Leds_Blanches (unsigned char Value)
{
	LEDS_BLANCHES=Value;		// Place l'inverse de la valeur sur le port (led active  l'tat bas)
}




// --------------------------------------------------------------------------
/* Commande les leds rouges
 *  0 = Leds teintes
 *  1 = Leds allumes
*/
void Leds_Rouges (unsigned char Value)
{
	LEDS_ROUGES=Value;		// Place l'inverse de la valeur sur le port (led active  l'tat bas)
}




