// Fichier Led.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Header de la librairie               *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 * .Grandes modifications :                             *
 *  __________________________________________________  *
 * |   DATE   |   Auteur   |          Detail          | *
 * |--------------------------------------------------| *
 * | 28/12/07 | P.Lucidarme| Cration et code des     | *
 * |          |			   | fonctions: 			  | *
 * |          |            | - ConfigureProcesseur    | *
 * |          |            | - Joy_X                  | *
 * |          |            | - Joy_Y                  | * 
 * |          |            |                          | *  
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |          |            |                          | *
 * |--------------------------------------------------| *
 * |__________|____________|__________________________| *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#define 	LEDS_BLEUS						PORTCbits.RC0				// Led active  l'tat bas
#define 	LEDS_BLANCHES					PORTCbits.RC1				// Led active  l'tat bas
#define 	LEDS_ROUGES						PORTCbits.RC2				// Led active  l'tat bas

#define 	TRIS_LEDS_BLEUS					TRISCbits.TRISC0			// Led active  l'tat bas
#define 	TRIS_LEDS_BLANCHES				TRISCbits.TRISC1			// Led active  l'tat bas
#define 	TRIS_LEDS_ROUGES				TRISCbits.TRISC2			// Led active  l'tat bas


// --------------------------------------------------------------------------
/* Mesures sur le capteurs
 *  0 = balle blanche
 *  1 = balle rouge
 *  2 = balle bleue
*/
unsigned char Mesures (void);



// --------------------------------------------------------------------------
/* Initialise les ports des leds en sortie
 * Puis teind toutes les leds
 *  Pas de paramtre 
*/
void Led_Init (void);




// --------------------------------------------------------------------------
/* Commande les leds bleus
 *  0 = Leds teintes
 *  1 = Leds allumes
*/
void Leds_Bleus (unsigned char);



// --------------------------------------------------------------------------
/* Commande les leds Blanches
 *  0 = Leds teintes
 *  1 = Leds allumes
*/
void Leds_Blanches (unsigned char);



// --------------------------------------------------------------------------
/* Commande les leds rouges
 *  0 = Leds teintes
 *  1 = Leds allumes
*/
void Leds_Rouges (unsigned char);


