// Fichier main.c
/////////////////////////////////////////////////////////

/****************************************************************
 *                                                    			*
 * .Date de cration : 11/01/08
    Date de modification : 21/02/08                         	*
 * .Auteurs :  Philipe Lucidarme	 Alexis Barre    			*
 *			   Quentin Dion	           							*
 *                          									*
 *                                                       		*
 * .Descriptions :                                      		*
 *      - Programme principal de la carte capteur de couleur  	*
 *                                                      		*
 *                                                      		*
 *                                                      		*
 * .Remarques :                                         		*
 *																*
 ****************************************************************/




// ------------ Directives de compilation
#pragma config WDT = OFF	// Pas de  watchdog
#pragma config OSC = HS		// Quartz HS pour un quartz 20MHz


// --------------------------------------------------------------------------
// Enttes ncessaires
#include <p18f252.h>		// Pour les registres du PIC18F252
#include <delays.h>    		// Pour les temporisations
#include <adc.h>			// Pour les convertisseurs A/N
#include <usart.h>			// Pour la liaison srie
#include <stdio.h>			// Pour les printf 

#include "led.h"
#include "can.h"





//--------------------------DEFINITIONS-----------------------------------------------//
#define 	CAPT_COUL_START				PORTCbits.RC5		//Bit de demande/confirmation de la couleur
#define 	CAPT_COUL_D0				PORTCbits.RC4		//Bit de donne de poid faible
#define 	CAPT_COUL_D1				PORTBbits.RB4		//Bit de donne de poid fort

#define 	TRIS_CAPT_COUL_START		TRISCbits.TRISC5	//pour configurer les entres sorties
#define 	TRIS_CAPT_COUL_D0			TRISCbits.TRISC4		
#define 	TRIS_CAPT_COUL_D1			TRISBbits.TRISB4	


#define		DELAY_CAPTEUR				Delay100TCYx(50)	// Dlay d'allumage des leds pour le capteur (entre deux couleurs de led)
#define		DELAY_INFORMATION			Delay10KTCYx(180)	// dlai pour informer de la couleur capte



#define		SEUIL_BLANC					850					// A baisser si les balles blanches sont prises pour des rouges
#define		SEUIL_ROUGE					525					// A baisser si les balles rouges sont prises pour des bleus

/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//                            Fonction Principale                          //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////



                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            
void main (void)
{

	int Bleu=0,Blanc=0,Rouge=0,Vide=0, i;
     

	TRIS_CAPT_COUL_START=1;							// Bit de start en entre
	TRIS_CAPT_COUL_D0=0;							// D0 en sortie
	TRIS_CAPT_COUL_D1=0;							// D1 en sortie
	
//Initialisation des LEDS et du CAN
	
	Led_Init();
	CAN_Init();

	
	// Configure la liaison srie  115200 Bauds:
	OpenUSART	(	USART_TX_INT_OFF	&	// Pas d'interruption sur l'mission
					USART_RX_INT_OFF	&	// Interruption sur la rception
					USART_ASYNCH_MODE	&	// Mode asynchrone
					USART_EIGHT_BIT		& 	// Transmission sur 8 bits (1 octet)
					USART_CONT_RX		&	// Reception continue
					USART_BRGH_HIGH		,	// Haute vitesse
					10);					// 21 = (20e6 / (16 * 57600))-1 
	

	while (1)
	{
		
		CAPT_COUL_D1=0;
		CAPT_COUL_D0=0;
		
		while (PORTCbits.RC5==0);						// On attend l'ordre de dbut de conversion
		
		Leds_Bleus(0);									//extinction des LEDS
		Leds_Blanches(0);
		Leds_Rouges(0);
		DELAY_CAPTEUR;
		Vide=CAN_Convert(ADC_CH0)+CAN_Convert(ADC_CH1)+CAN_Convert(ADC_CH2);
			
		Leds_Bleus(1);								
		Leds_Blanches(0);
		Leds_Rouges(0);
		DELAY_CAPTEUR;
		Bleu=(CAN_Convert(ADC_CH0)+CAN_Convert(ADC_CH1)+CAN_Convert(ADC_CH2))-Vide;

		Leds_Bleus(0);								
		Leds_Blanches(1);
		Leds_Rouges(0);
		DELAY_CAPTEUR;
		Blanc=(CAN_Convert(ADC_CH0)+CAN_Convert(ADC_CH1)+CAN_Convert(ADC_CH2))-Vide;

		Leds_Bleus(0);								
		Leds_Blanches(0);
		Leds_Rouges(1);
		DELAY_CAPTEUR;
		Rouge=(CAN_Convert(ADC_CH0)+CAN_Convert(ADC_CH1)+CAN_Convert(ADC_CH2))-Vide;
		
		Leds_Bleus(0);								
		Leds_Blanches(0);	
		Leds_Rouges(0);
		
		if (Blanc>SEUIL_BLANC)				// C'est une balle blanche
		{
			CAPT_COUL_D0=0;
			CAPT_COUL_D1=1;
			Leds_Blanches(1);	
			while (PORTCbits.RC5);
			DELAY_INFORMATION;
			Leds_Blanches(0);		
		}
		else
		{
			if (Rouge>SEUIL_ROUGE)			// C'est une balle rouge
			{
				CAPT_COUL_D0=1;
				CAPT_COUL_D1=1;
				Leds_Rouges(1);
				while (PORTCbits.RC5);
				DELAY_INFORMATION;
				Leds_Rouges(0);		
			}
			else							// Donc c'est une balle bleue !
			{
				CAPT_COUL_D0=1;
				CAPT_COUL_D1=0;				
				Leds_Bleus(1);								
				while (PORTCbits.RC5);
				DELAY_INFORMATION;		
				Leds_Bleus(0);
				
			}
		}	
		
		printf ("Blanc=%d \tRouge=%d\t Bleu=%d\n",Blanc,Rouge,Bleu);
	}
}



